.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

.data

pcTable	db 0,1,1,2,1,2,2,3,1,2,2,3,2,3,3,4,1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5
	db 1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6
	db 1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6
	db 2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7
	db 1,2,2,3,2,3,3,4,2,3,3,4,3,4,4,5,2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6
	db 2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7
	db 2,3,3,4,3,4,4,5,3,4,4,5,4,5,5,6,3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7
	db 3,4,4,5,4,5,5,6,4,5,5,6,5,6,6,7,4,5,5,6,5,6,6,7,5,6,6,7,6,7,7,8
.code
start:	push 1
	call ShowCpu	; print brand string and SSE level
	SleepMs =	50	; test if anything changes when changing this
	LOOP_COUNT =	100000	; One Mio would be a typical value
	Source = 10101010101010101010101010101010b
;		xor ebx, ebx
;		.Repeat
;			mov eax, ebx
;					or ecx, -1
;					mov edx, ecx
;					@@:
;					inc ecx
;					btr eax, edx
;					bsf edx, eax
;					jnz @B
;					print str$(ecx), ","
;					inc ebx
;					mov eax, ebx
;					and eax, 31
;					.if Zero?
;						print chr$(13, 10)
;					.endif
;		.Until ebx==256
	REPEAT 2
		if 0
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 32
		    mov eax, Source
		    mov ah,al
		    shr ah,1
		    and ax,05555h
		    add al,ah
		    mov ah,al
		    shr ah,2
		    and ax,03333h
		    add al,ah
		    mov ah,al
		    shr ah,4
		    and ax,00F0Fh
		    add al,ah
		ENDM
		movzx esi, al
		counter_end
		shr eax, 5
		print str$(eax), 9, "cycles for Clive, result="
		print str$(esi), 13, 10
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 32
				mov eax, Source
				xor edx, edx
				mov ecx, 8
				@@:
				shr eax, 1
				adc dl,dh
				dec ecx
				jnz @B
		ENDM
		movzx esi, dl
		counter_end
		shr eax, 5
		print str$(eax), 9, "cycles for Dave, result="
		print str$(esi), 13, 10
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 32
				mov eax, Source
				or ecx, -1
				mov edx, ecx
				@@:
				inc ecx
				btr eax, edx
				bsf edx, eax
				jnz @B
		ENDM
		movzx esi, cl
		counter_end
		shr eax, 5
		print str$(eax), 9, "cycles for Jochen, result="
		print str$(esi), 13, 10
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 32
				mov eax, Source
				movzx eax, al
				movzx eax, byte ptr pcTable[eax]
		ENDM
		mov esi, eax
		counter_end
		add eax, 31
		shr eax, 5
		print str$(eax), 9, "cycles for table, byte, result="
		print str$(esi), 13, 10
		endif
		invoke Sleep, 100	; table dword
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 32
				push ecx
				push ebx
				mov ebx, Source
				movzx ecx, bh
				movzx eax, byte ptr pcTable[ecx]
				movzx ecx, bl
				movzx edx, byte ptr pcTable[ecx]
				bswap ebx
				movzx ecx, bh
				add eax, edx
				movzx edx, byte ptr pcTable[ecx]
				add eax, edx
				movzx ecx, bl
				movzx edx, byte ptr pcTable[ecx]
				add eax, edx
				pop ebx
				pop ecx
		ENDM
		mov esi, eax
		counter_end
		add eax, 31
		shr eax, 5
		print str$(eax), 9, "cycles for table, dword, result="
		print str$(esi), 13, 10
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 32
				mov eax, Source
				xor edx, edx
				REPEAT 32
					shr eax, 1
					adc edx, 0
				ENDM
		ENDM
		movzx esi, dl
		counter_end
		shr eax, 5
		print str$(eax), 9, "cycles for brute, dword, result="
		print str$(esi), 13, 10

		if 0
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT 32
				mov eax, Source
				xor edx, edx
                                shl eax, 24
				add eax, eax
				adc edx, 0
				add eax, eax
				adc edx, 0
				add eax, eax
				adc edx, 0
				add eax, eax
				adc edx, 0
				add eax, eax
				adc edx, 0
				add eax, eax
				adc edx, 0
				add eax, eax
				adc edx, 0
				add eax, eax
				adc edx, 0
		ENDM
		movzx esi, dl
		counter_end
		shr eax, 5
		print str$(eax), 9, "cycles for Brute2, result="
		print str$(esi), 13, 10
		endif
	print chr$(13, 10)
	ENDM

;		OPT_DebugA	/DMyVersion="Assembled by jj2007"
;	ifdef MyVersion
;		tmp$ CATSTR <print ">, MyVersion, <", 13, 10>
;		tmp$
;	endif

	inkey chr$(13, 10, "--- ok ---", 13)
	exit

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]